Bug 464250 - unable to install i386 packages in bi-arch machine
unable to install i386 packages in bi-arch machine
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
rawhide
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Seth Vidal
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-09-26 17:20 EDT by Donald Cohen
Modified: 2014-01-21 18:06 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-09-26 20:52:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Donald Cohen 2008-09-26 17:20:54 EDT
Description of problem:
My understanding is that I should be able to do
$ yum install firefox.i386

in order to install a 32 bit version of firefox (so I can run java applets!)
But when I try to do that I get

Loaded plugins: refresh-packagekit
Setting up Install Process
Parsing package install arguments
No package firefox.i386 available.
Nothing to do

Is there something important I'm missing?

Version-Release number of selected component (if applicable):
This is Fedora 10, with suitable yum updates and installs.

How reproducible:
enter the command above

Steps to Reproduce:
1.enter the command above
2.
3.
  
Actual results:
the results above

Expected results:
32 bit version should be installed

Additional info:
Comment 1 James Antill 2008-09-26 20:52:29 EDT
 From Fedora 9 onwards there is no firefox/galeon/epiphany for .i386

 AIUI you can install nspluginwrapper.i386 and nspluginwrapper.x86_64 to run .i386 plugins inside the .x86_64 firefox.
Comment 2 Donald Cohen 2008-09-26 22:11:56 EDT
http://fedora.secsup.org/linux/development/i386/os/Packages/ shows
 firefox-3.0.1-1.fc10.i386.rpm   
Isn't that a firefox for .i386 ?
Why should I not be able to install it?
Comment 3 James Antill 2008-09-28 16:01:52 EDT
 You can install it, manually.

 However the x86_64 yum doesn't look at both the x86_64 and .i386 repos. ... it just look sa tthe x86_64 repo. and Fedora decides which .i386 packages to put in that. They decided not to put the .i386 firefox in, so it isn't available by default.
Comment 4 Donald Cohen 2008-10-03 14:44:41 EDT
(In reply to comment #1)
>  From Fedora 9 onwards there is no firefox/galeon/epiphany for .i386
> 
>  AIUI you can install nspluginwrapper.i386 and nspluginwrapper.x86_64 to run
> .i386 plugins inside the .x86_64 firefox.

So far I've not managed to get this to work - see bug 465531
Comment 5 Donald Cohen 2008-10-03 15:27:26 EDT
(In reply to comment #3)
>  You can install it, manually.
> 
>  However the x86_64 yum doesn't look at both the x86_64 and .i386 repos. ... it
> just look sa tthe x86_64 repo. and Fedora decides which .i386 packages to put
> in that. They decided not to put the .i386 firefox in, so it isn't available by
> default.

It's nice that yum installs the other packages it thinks I need for this,
but it seems to only install the x86_64 files !!
When I try to install ALL the files in the package:
$ rpm -v -i --allfiles firefox-3.0.2-1.fc10.i386.rpm
error: Failed dependencies:
	libgconf-2.so.4 is needed by firefox-3.0.2-1.fc10.i386
	libgnomevfs-2.so.0 is needed by firefox-3.0.2-1.fc10.i386
	libstartup-notification-1.so.0 is needed by firefox-3.0.2-1.fc10.i386
	libxpcom.so is needed by firefox-3.0.2-1.fc10.i386
	libxul.so is needed by firefox-3.0.2-1.fc10.i386

Is there any way to get yum to install ALL of the files?
Comment 6 seth vidal 2008-10-03 15:41:02 EDT
I'm unsure if this will work given the pkg you want to install but please try:

yum install firefox-3.0.2-1.fc10.i386.rpm


in the directory where the firefox package has been downloaded.
Comment 7 Donald Cohen 2008-10-03 16:17:28 EDT
Package firefox-3.0.2-1.fc10.i386.rpm is not signed
[2008-10-03 12:54:30 root@number11 /tmp]
$ yum --nogpgcheck -v install firefox-3.0.2-1.fc10.i386.rpm 
 ... seems to do a lot of stuff, possibly even the right stuff ...

At this point it's not clear what has been written/overwritten.
$ which firefox
/usr/bin/firefox
but that still seems to run the 64 bit version

See what you can make of this:

$ /usr/lib/firefox-3.0.2/firefox 
Gtk-Message: Failed to load module "canberra-gtk-module": libcanberra-gtk-module.so: cannot open shared object file: No such file or directory

(firefox:6281): Gtk-WARNING **: Unable to locate theme engine in module_path: "nodoka",

(firefox:6281): Gtk-WARNING **: Unable to locate theme engine in module_path: "nodoka",
Gtk-Message: Failed to load module "gnomebreakpad": libgnomebreakpad.so: cannot open shared object file: No such file or directory
Fontconfig error: "conf.d", line 1: no element found
Fontconfig warning: line 73: unknown element "cachedir"
Fontconfig warning: line 74: unknown element "cachedir"
Gtk-Message: Failed to load module "canberra-gtk-module": libcanberra-gtk-module.so: cannot open shared object file: No such file or directory

(firefox:6281): Gtk-WARNING **: Unable to locate theme engine in module_path: "nodoka",

(firefox:6281): Gtk-WARNING **: Unable to locate theme engine in module_path: "nodoka",
Gtk-Message: Failed to load module "gnomebreakpad": libgnomebreakpad.so: cannot open shared object file: No such file or directory
Fontconfig error: "conf.d", line 1: no element found
Fontconfig warning: line 73: unknown element "cachedir"
Fontconfig warning: line 74: unknown element "cachedir"
Segmentation fault
Comment 8 seth vidal 2008-10-03 16:32:34 EDT
Okay, at this point it is very hard to tell what you do and what you do not have installed. Also it's hard to figure out what you just installed.

run this:

yum list installed firefox\*
Comment 9 Donald Cohen 2008-10-03 16:35:49 EDT
(In reply to comment #8)
> Okay, at this point it is very hard to tell what you do and what you do not
> have installed. Also it's hard to figure out what you just installed.
> 
> run this:
> 
> yum list installed firefox\*

$ yum list installed firefox\*
Loaded plugins: refresh-packagekit
Installed Packages
firefox.i386                             3.0.2-1.fc10           installed       
firefox.x86_64                           3.0.2-1.fc10           installed      

I forgot to ask why your command,
yum install firefox-3.0.2-1.fc10.i386.rpm
was different from the command I originally used:
$ yum localinstall firefox-3.0.2-1.fc10.i386.rpm
Comment 10 seth vidal 2008-10-03 16:40:37 EDT
okay, so when you install both - the binary that's going to be used b/c of how rpm does multilib on x86_64 is the 64bit binary.

If you want to use the i386 binary you're going to have to do:

yum remove firefox

yum --nogpgcheck install firefox-3.0.2-1.fc10.i386.rpm
Comment 11 Donald Cohen 2008-10-03 16:48:39 EDT
I can't have both?  If I want to help debug bug 465531 I have to install the 64bit version.  I realize that just typing "firefox" can only run one of them, 
but I expected that some other path could still be used to run the other.
 ... ok, for now I'll try it.
Comment 12 Donald Cohen 2008-10-03 16:54:17 EDT
Well, that all seemed to go as expected, but here's the result:

[2008-10-03 13:48:42 root@number11 /tmp]
$ firefox
Gtk-Message: Failed to load module "canberra-gtk-module": libcanberra-gtk-module.so: cannot open shared object file: No such file or directory

(firefox:6430): Gtk-WARNING **: Unable to locate theme engine in module_path: "nodoka",

(firefox:6430): Gtk-WARNING **: Unable to locate theme engine in module_path: "nodoka",
Gtk-Message: Failed to load module "gnomebreakpad": libgnomebreakpad.so: cannot open shared object file: No such file or directory
Fontconfig error: "conf.d", line 1: no element found
Fontconfig warning: line 73: unknown element "cachedir"
Fontconfig warning: line 74: unknown element "cachedir"
/usr/lib/firefox-3.0.2/run-mozilla.sh: line 131:  6430 Segmentation fault      "$prog" ${1+"$@"}


I'm entering this into konqueror, btw, now that I can no longer use firefox!
Comment 13 James Antill 2008-10-03 16:55:56 EDT
 That's not needed, /usr/bin/firefox is still a shell script that runs the 64 or 32 bit version, depending ... the fact that firefox.i386 SEGVs on .x86_64 is a real problem, but probably not one that we (yum maintainers) can do anything about.
Comment 14 Donald Cohen 2008-10-03 17:04:00 EDT
I've now managed to install libcanberra-gtk2 and so get rid of the first message, but still end up with segfault.
Sounds like I should add this as a new firefox bug.

Still want to know the difference between install and localinstall.
Comment 15 Donald Cohen 2008-10-03 19:31:35 EDT
I know this is not the place to ask for general help, but ...
my machine crashed while doing "yum update" - in the middle of installing several hundred updates.  I now do yum update and get back
No Packages marked for Update
How can I recover?
Comment 16 James Antill 2008-10-03 23:21:09 EDT
run: yum-complete-transaction
Comment 17 Donald Cohen 2008-12-12 01:38:37 EST
perhaps this should be a new bug, but ...
What's the problem here and how can I fix it?
====
[root@number11 ~]# yum-complete-transaction 
Loaded plugins: refresh-packagekit
rawhide                                                  | 2.8 kB     00:00     
There are 2 outstanding transactions to complete. Finishing the most recent one
The remaining transaction had 410 elements left to run
Nothing in the unfinished transaction to cleanup.
Cleaning up completed transaction file
Traceback (most recent call last):
  File "/usr/sbin/yum-complete-transaction", line 208, in <module>
    util = YumCompleteTransaction()
  File "/usr/sbin/yum-complete-transaction", line 115, in __init__
    self.main()
  File "/usr/sbin/yum-complete-transaction", line 189, in main
    self.clean_up_ts_files(timestamp, self.conf.persistdir)
  File "/usr/sbin/yum-complete-transaction", line 123, in clean_up_ts_files
    if os.path.exists(f):
NameError: global name 'os' is not defined
[root@number11 ~]#
Comment 18 seth vidal 2008-12-12 09:55:33 EST
comment #17 is bug 470458

and if you have new questions, open a new bug. Do not use one that has been closed for 2 months.

Note You need to log in before you can comment on or make changes to this bug.